#include "HUDManager.h"

#include <genesis.h>
#include <KDebug.h>
#include <vdp_spr.h>
#include <vdp_tile.h>

#include "Collisions.h"
#include "Debug.h"
#include "generated\DebugSettings.h"
#include "GameFont.h"
#include "LevelManager.h"
#include "MathUtils.h"
#include "PlayerManager.h"
#include "ObjectManager.h"
#include "exported\ExportedGenResSprites.h"
#include "VDP_Extra.h"

u32 oldFPS;

inline void DrawFPSString()
{
    if (debugSettings.showFPSCounter == FALSE)
    {
        return;
    }

    u16 fps = getFPS();
    u16 n1 = fps % 10;
    fps /= 10;
    u16 n2 = fps % 10;
    fps /= 10;
    u16 n3 = fps % 10;

    u16 tile_attr = TILE_ATTR_FULL(PAL0, 1, 0, 0, TILE_FONTINDEX + 16);
    u8 spriteSize = SPRITE_SIZE(1, 1);

    MyVDP_setSprite(144, 8, spriteSize, tile_attr + n3);
    MyVDP_setSprite(152, 8, spriteSize, tile_attr + n2);
    MyVDP_setSprite(160, 8, spriteSize, tile_attr + n1);
}

void HUDManager_Draw()
{
    DrawFPSString();
}

void HUDManager_Init()
{
    oldFPS = 0;
}
