#ifndef MAP_INCLUDE_H
#define MAP_INCLUDE_H

#include "Door.h"
#include <genres.h>
#include <vdp_spr.h>
#include "VDPInfo.h"
#include "ObjectStreamer.h"

#define MAPTYPE_VDP         0
#define MAPTYPE_HORIZONTAL  1
#define MAPTYPE_VERTICAL    2
#define MAPTYPE_8WAY        3

typedef struct map_struct
{
    void (*LoadVDPAssets)(const struct map_struct* thismap);
    SpawnSections                                  spawnSections;
    unsigned short                                 numSpawnSections;
    unsigned short                                 width;
    unsigned short                                 height;
    unsigned short                                 mapType;
    unsigned short                                 vdpPlaneWidth;
    unsigned short                                 vdpPlaneHeight;
    unsigned short const*                          tilemap;
    struct genresSprites*                          tilesetSprite;
    VDPInfo*                                       tilesetVDPInfo;
    unsigned short const*                          tilesetAttributes;
    unsigned short                                 playerStartX;
    unsigned short                                 playerStartY;
    Door                                           door;
} map_struct;

typedef struct map_struct VPMap;

#endif

