#include "TitleScreen.h"

#include <genesis.h>

#include "LevelManager.h"
#include "JoypadManager.h"
#include "StateManager.h"
#include "VDP_Extra.h"
#include "VDPManager.h"
#include "exported\ExportedMaps.h"
#include "exported\ExportedGenResSprites.h"

void TitleScreen_Update()
{
    if (joystickState.startPressed)
    {
        StateManager_ChangeToState(LevelManager_Init);
    }
}

void TitleScreen_Start()
{
    MyVDP_waitVSync();

    VDP_setEnable(0);

    VDPManager_ResetDisplay();

    VDPManager_ResetVDPInfo();
    VDP_setPalette(PAL2, wharf_tilesetSprite.pal);

    titlescreenbackground_map.LoadVDPAssets(&titlescreenbackground_map);

    MyVDP_setTileMapRect(BPLAN, 
                         titlescreenbackground_map.tilemap, 
                         TILE_ATTR_FULL(PAL2, 0, 0, 0, titlescreenbackground_map.tilesetVDPInfo->startIndex), 
                         0, 
                         0, 
                         titlescreenbackground_map.width, 
                         titlescreenbackground_map.height);

    VDP_setEnable(1);

    StateManager_ChangeToState(TitleScreen_Update);
}
