#include "ending.h"

#include <genesis.h>

#include "..\Debug.h"
#include "..\generated\AllLevels.h"
#include "..\exported\ExportedGenResSprites.h"
#include "..\exported\ExportedMaps.h"
#include "..\FadeManager.h"
#include "..\MathUtils.h"
#include "..\VDPManager.h"
#include "..\PlayerManager.h"
#include "..\TitleScreen.h"
#include "..\JoypadManager.h"

u16 endingTimer = 0;

void Ending_InitLevel()
{
    LOAD_GENRES_SPRITE_TO_VDP(enemy);

    FadeManager_SetPalette(PAL0, girlSprite.pal);
    FadeManager_SetPalette(PAL1, pingouin_roseSprite.pal);
    FadeManager_SetPalette(PAL2, wharf_tilesetSprite.pal);
    FadeManager_SetPalette(PAL3, wharf_tilesetSprite.pal);

    endingTimer = 0;
    isEndingScreen = 1;
}

void Ending_UpdateLevel()
{
    endingTimer++;

    if (//endingTimer > 300 &&
        joystickState.startPressed)
    {
        StateManager_ChangeToState(TitleScreen_Start);
    }
}

const Level ending =
{
    Ending_InitLevel,
    Ending_UpdateLevel,
    &ending_map,
    &background_map,
    NULL
};

