# helper script that generates .h and .c files declaring the list of exported sprites in .crc files

import sys
import os
import fnmatch
from glob import glob
print "************** Generating Bitmap Imports **************"
#filenames = glob(sys.argv[1])

matches = []
for root, dirnames, filenames in os.walk('..\\gamedata'):
    for filename in fnmatch.filter(filenames, "*.rc"):
        matches.append(os.path.join(root, filename))
        
filenames = matches

destination_path = "exported"
if not os.path.exists(destination_path):
    os.makedirs(destination_path)

exported_c = open("exported\\ExportedGenResSprites.c", "w")
exported_c.write("// **************************************************** \n")
exported_c.write("// This file is automatically generated by\n")
exported_c.write("// generate_genres_sprites.py\n")
exported_c.write("// **************************************************** \n\n")
exported_c.write('#include "ExportedGenResSprites.h"\n\n')

exported_h = open("exported\\ExportedGenResSprites.h", "w")
exported_h.write("// **************************************************** \n")
exported_c.write("// This file is automatically generated by\n")
exported_c.write("// generate_genres_sprites.py\n")
exported_h.write("// **************************************************** \n\n")
exported_h.write('#ifndef EXPORTED_GENRES_SPRITES_H\n')
exported_h.write('#define EXPORTED_GENRES_SPRITES_H\n\n')
exported_h.write('#include "..\VDPManager.h"\n\n')

for filename in filenames:
    print "Generating from " + filename + ":"
    f = open(filename)
    content = f.readlines()
    f.close()

    exported_h.write("// ************************ \n")
    exported_h.write("// From " + filename + "\n")
    exported_h.write("// ************************ \n\n")

    
    exported_c.write("// ************************ \n")
    exported_c.write("// From " + filename + "\n")
    exported_c.write("// ************************ \n\n")


    for line in content:
        line = line.strip()
        if line == "; end":
            break
        startindex = line.find("SPRITE")
        if startindex >= 0:
            startindex = line.find(" ", startindex + 1)
            endindex = line.find('"', startindex)
            exportedSpriteName = line[startindex:endindex].strip()
            exportedSpriteName = exportedSpriteName[:exportedSpriteName.find("Sprite")]
            print "    Exporting " + exportedSpriteName
            outstring = "IMPORT_GENRES_SPRITE(" + exportedSpriteName + ");\n"
            exported_h.write(outstring)
            exported_c.write("VDPINFO(" + exportedSpriteName + ");\n")
        else:
            line = line.strip()
            startindex = line.find(";")
            if startindex >= 0:
                exported_h.write("//" + line[1:] + "\n")
                exported_c.write("//" + line[1:] + "\n")
            else:
                if line == "":
                    exported_h.write("\n")
                    exported_c.write("\n")
                    
                
exported_c.write('\n')
exported_c.close()

exported_h.write('\n#endif\n')
exported_h.close()
        
