# helper script that generates .h and .c files from graphics gale files

import sys
import os
import time

#changing the destination folder requires updating the SGDK makefile too
destination_folder = "exported\\GGAnimations"
destination_path = os.path.realpath('.') + "\\" + destination_folder

from glob import glob
print "************** Exporting Graphics Gale To Code **************"
filenames = glob('..\gamedata\GGAnimations\*.gal')

    
includes=[]
    
for filename in filenames:
    sourcefilename = os.path.realpath('.') + "\\" + filename
    
    outputname = os.path.splitext(filename)[0]
    outputname = os.path.basename(outputname)   
    destinationfilename = os.path.realpath('.') + '\\' + destination_folder + '\\' + outputname + '.c'
    
    includes.append(outputname + ".h")
    
    docopy = False
    
    if (os.path.exists(destinationfilename) == False):
        #print destinationfilename + " is missing. Copying"
        docopy = True
    
    if docopy == False:
        sourcetime = os.path.getmtime(sourcefilename)
        destinationtime = os.path.getmtime(destinationfilename)

        if sourcetime > destinationtime:
            #print "sourcefilename is newer than destination filename"
            docopy = True

    if docopy == True:
        if not os.path.exists(destination_path):
            os.makedirs(destination_path)
    
        commandline = os.path.realpath('.') + "\..\Tools\gale2c\\bin\gale2c.exe " + filename + " " + destination_path
        print "Exporting " + filename + " to " + destination_folder
        os.system(commandline)
    
exported_h = open("exported\\ExportedGGAnimations.h", "w")
exported_h.write("// **************************************************** \n")
exported_h.write("// This file is automatically generated by\n")
exported_h.write("// export_graphicsgale_animations.py\n")
exported_h.write("// **************************************************** \n\n")
exported_h.write('#ifndef EXPORTED_GRAPHICSGALE_ANIMATIONS_H\n')
exported_h.write('#define EXPORTED_GRAPHICSGALE_ANIMATIONS_H\n\n')

for include in includes:
    exported_h.write('#include "GGAnimations\\' + include + '"\n')

exported_h.write('\n#endif\n')
exported_h.close()
    
