# helper script that generates AllLevels.h file
#
# It scrapes the contents of the Levels folder and generates a header file
# that includes all the header files.
#
#
#

import sys
import os


from glob import glob
print "************** Generating AllLevels.h and AllLevels.c **************"
filenames = glob('Levels\*.h')

def writehfile():
    file = open("generated\AllLevels.h", "w")
    file.write("// **************************************************** \n")
    file.write("// This file is automatically generated by\n")
    file.write("// generate_alllevels_header.py\n")
    file.write("// **************************************************** \n\n")
    file.write('#ifndef ALL_LEVELS_INCLUDE_H\n')
    file.write('#define ALL_LEVELS_INCLUDE_H\n\n')
    
    for filename in filenames:
        file.write('#include "..\\' + filename + '"\n')

    file.write('\n\n')
    file.write('#define NUM_LEVELS ' + str(len(filenames)) + '\n')
    file.write('#define LEVEL_NAME_LENGTH 10\n\n')
    file.write('const Level* const levels[NUM_LEVELS];\n')
    file.write('const char* const levelNames[NUM_LEVELS];\n')

    file.write('\n#endif\n')
    file.close()  

def writecfile():
    file = open("generated\AllLevels.c", "w")
    file.write("// **************************************************** \n")
    file.write("// This file is automatically generated by\n")
    file.write("// generate_alllevels_header.py\n")
    file.write("// **************************************************** \n\n")
    file.write('#include "AllLevels.h"\n\n')

    file.write('const Level* const levels[' + str(len(filenames)) + '] = \n{\n')
    for filename in filenames:
        filename = filename.split('.')[0]
        filename = filename.split('\\')[1]
        file.write('    &' + filename  + ',\n')
    file.write('};\n\n')


    file.write('const char* const levelNames[' + str(len(filenames)) + '] = \n{\n')
    for filename in filenames:
        filename = filename.split('.')[0]
        filename = filename.split('\\')[1]
        file.write('    "' + filename + '",\n')
    file.write('};\n\n')

writehfile()
writecfile()